#include "wx/wx.h"
#include "algorithm.h"
#include "alg_try.h"
#include "main.h"

// Just some testalgorithms which don't do much useful things :)

AlgTry1::AlgTry1() : Algorithm("AlgTry1")
{
}

void AlgTry1::Execute()
{
    fprintf(stderr, "\nAlgTry1::Execute");

    wxImage * bmp = PIXALCO.GetImage(0, 0);
    if ( !bmp )
        return;
    
    unsigned char* data = bmp->GetData();
    int width = bmp->GetWidth();
    int height = bmp->GetHeight();
    int lineSize = width * 3;
    
    for ( int y = 0; y < height; y++ )
    {
        for ( int x=0; x < width*3; x+=3 )
        {
            data[y*lineSize+x] = 255-data[y*lineSize+x+1];
            data[y*lineSize+x+1] = 255-data[y*lineSize+x+2];
            data[y*lineSize+x+2] = 255-data[y*lineSize+x];
        }
    }
}

AlgTry2::AlgTry2() : Algorithm("AlgTry2")
{
}

void AlgTry2::Execute()
{
    fprintf(stderr, "\nAlgTry2::Execute");

    wxImage * bmp = PIXALCO.GetImage(0, 0);
    wxImage * bmp2 = PIXALCO.GetImageSameType(1, bmp);
    if ( !bmp || !bmp2 )
        return;
    
    unsigned char* data = bmp->GetData();
    unsigned char* data2 = bmp2->GetData();
    int width = bmp->GetWidth();
    int height = bmp->GetHeight();
    int lineSize = width * 3;
    int avg[3];
    avg[0] = 0;
    avg[1] = 0;
    avg[2] = 0;
    
    for ( int y = 0; y < height; y++ )
    {
        for ( int x=0; x < width*3; x+=3 )
        {
            avg[0] += data[y*lineSize+x];
            avg[1] += data[y*lineSize+x+1];
            avg[2] += data[y*lineSize+x+2];
        }
    }
    
    avg[0] /= width*height;
    avg[1] /= width*height;
    avg[2] /= width*height;   
    
    for ( int y = 0; y < height; y++ )
    {
        for ( int x=0; x < width*3; x+=3 )
        {
            if ( data[y*lineSize+x] < avg[0] )
                data2[y*lineSize+x] = 0;
            else
                data2[y*lineSize+x] = 255;
            if ( data[y*lineSize+x+1] < avg[1] )
                data2[y*lineSize+x+1] = 0;
            else
                data2[y*lineSize+x+1] = 255;
            if ( data[y*lineSize+x+2] < avg[2] )
                data2[y*lineSize+x+2] = 0;
            else
                data2[y*lineSize+x+2] = 255;
            
//            data[y*lineSize+x] = 255-data[y*lineSize+x+2];
//            data[y*lineSize+x+1] = 255-data[y*lineSize+x];
//            data[y*lineSize+x+2] = 255-data[y*lineSize+x+1];
        }
    }
}


AlgTry3::AlgTry3() : Algorithm("AlgTry3")
{
}

void AlgTry3::Execute()
{
    fprintf(stderr, "\nAlgTry3::Execute");
    wxImage * bmp = PIXALCO.GetImage(0, 0);
    wxImage * bmp2 = PIXALCO.GetImageSameType(1, bmp);
    wxImage * bmp3 = PIXALCO.GetImageSameType(2, bmp);
    if ( !bmp || !bmp2 || !bmp3)
        return;

    unsigned char* data = bmp->GetData();
    unsigned char* data2 = bmp2->GetData();
    unsigned char* data3 = bmp3->GetData();
    int width = bmp->GetWidth();
    int height = bmp->GetHeight();
    int lineSize = width * 3;
    
    for ( int y = 0; y < height; y++ )
    {
        for ( int x=0; x < width*3; x+=3 )
        {
            data[y*lineSize+x] = 255-data[y*lineSize+x];
            data[y*lineSize+x+1] = 255-data[y*lineSize+x+1];
            data[y*lineSize+x+2] = 255-data[y*lineSize+x+2];
        
            data2[y*lineSize+x] = data[y*lineSize+x+1];
            data2[y*lineSize+x+1] = data[y*lineSize+x+2];
            data2[y*lineSize+x+2] = data[y*lineSize+x];
            
            data3[y*lineSize+x] = data[y*lineSize+x+2];
            data3[y*lineSize+x+1] = data[y*lineSize+x];
            data3[y*lineSize+x+2] = data[y*lineSize+x+1];
        }
    }
}

RGBtoBlackWhiteAvg::RGBtoBlackWhiteAvg() : Algorithm("RGBtoBlackWhiteAvg")
{
}

void RGBtoBlackWhiteAvg::Execute()
{
    wxImage * bmp = PIXALCO.GetImage(0, 0);
    if ( !bmp )
        return;

    int width = bmp->GetWidth();
    int height = bmp->GetHeight();
    int lineSize = width * 3;
    unsigned char* data = bmp->GetData();
    for ( int y = 0; y < height; y++ )
    {
        for ( int x=0; x < width*3; x+=3 )
        {
            data[y*lineSize+x] = (data[y*lineSize+x] + data[y*lineSize+x+1] + data[y*lineSize+x+2]) / 3;
            data[y*lineSize+x+1] = data[y*lineSize+x];
            data[y*lineSize+x+2] = data[y*lineSize+x];
        }
    }
}

RGBtoBlackWhiteNTSC::RGBtoBlackWhiteNTSC() : Algorithm("RGBtoBlackWhiteNTSC")
{
}

void RGBtoBlackWhiteNTSC::Execute()
{
    wxImage * bmp = PIXALCO.GetImage(0, 0);
    if ( !bmp )
        return;
    
    int width = bmp->GetWidth();
    int height = bmp->GetHeight();
    int lineSize = width * 3;
    unsigned char* data = bmp->GetData();
    for ( int y = 0; y < height; y++ )
    {
        for ( int x=0; x < width*3; x+=3 )
        {
            data[y*lineSize+x] = (int) (0.299f * (float)data[y*lineSize+x]
                                        + 0.587f * (float)data[y*lineSize+x+1]
                                        + 0.114f * (float)data[y*lineSize+x+2]);
            data[y*lineSize+x+1] = data[y*lineSize+x];
            data[y*lineSize+x+2] = data[y*lineSize+x];
        }
    }
}

MovieDiffImage::MovieDiffImage() : Algorithm("AlgMovieDiffImage")
{
}

void MovieDiffImage::Execute()
{
    wxImage * bmp = PIXALCO.GetImage(0, 0);
    wxImage * bmp2 = PIXALCO.GetImageSameType(1, bmp);
    wxImage * bmp3 = PIXALCO.GetImageSameType(2, bmp);
    if ( !bmp || !bmp2 || !bmp3)
        return;
    
    wxImage * old1 = PIXALCO.GetImageFromMovieBuffer(1);
    wxImage * old2 = PIXALCO.GetImageFromMovieBuffer(9);
    if (        !PIXALCO.IsSameImageType(bmp, old1)
          ||    !PIXALCO.IsSameImageType(bmp, old2)
       )
    {
        return;
    }

    unsigned char* dataNew = bmp->GetData();
    unsigned char* dataOld1 = old1->GetData();
    unsigned char* dataOld2 = old2->GetData();
    unsigned char* dataTarget1 = bmp2->GetData();
    unsigned char* dataTarget2 = bmp3->GetData();
    int width = bmp->GetWidth();
    int height = bmp->GetHeight();
    int lineSize = width * 3;

    for ( int y = 0; y < height; y++ )
    {
        for ( int x=0; x < width*3; x+=3 )
        {
            dataTarget1[y*lineSize+x] = abs( dataOld1[y*lineSize+x] - dataNew[y*lineSize+x] );
            dataTarget1[y*lineSize+x+1] = abs( dataOld1[y*lineSize+x+1] - dataNew[y*lineSize+x+1] );
            dataTarget1[y*lineSize+x+2] = abs( dataOld1[y*lineSize+x+2] - dataNew[y*lineSize+x+2] );

            dataTarget2[y*lineSize+x] = abs( dataOld2[y*lineSize+x] - dataNew[y*lineSize+x] );
            dataTarget2[y*lineSize+x+1] = abs( dataOld2[y*lineSize+x+1] - dataNew[y*lineSize+x+1] );
            dataTarget2[y*lineSize+x+2] = abs( dataOld2[y*lineSize+x+2] - dataNew[y*lineSize+x+2] );
        }
    }    
}
