#include "wx/wx.h"
#include "image_object.h"

ImageObject::ImageObject(const string &name_)
{
    mRefCount = 1;
    mImage = new wxImage();
    mDisplayName = name_;
}

ImageObject::ImageObject()
{
    mRefCount = 1;
    mImage = NULL;
}

ImageObject::~ImageObject()
{
    delete mImage;
}

int ImageObject::AddRef()
{
    return ++mRefCount;
}

int ImageObject::Release()
{
    assert(mRefCount > 0 );
    if ( --mRefCount == 0)
        delete this;
    return mRefCount;
}

void ImageObject::SetImage(wxImage* img_)
{
    delete mImage;
    mImage = img_;
}

ImageObject* ImageObject::Copy()
{
    ImageObject* copy = new ImageObject();
    if ( copy )
    {
        copy->mImage = new wxImage(mImage->Copy());
        copy->mDisplayName = mDisplayName;
    }
    return copy;
}
